PROGRAM dump_headers
!
! Dump the SCT and first PCT from VIPIR Version 1.2 RIQ raw data files
!

IMPLICIT NONE
INCLUDE 'sct.f90'
INCLUDE 'pct.f90'
INCLUDE 'pri.f90'   ! PRI

TYPE(SCTtype) SCT
TYPE(PCTtype) PCT
TYPE(PRItype) PRI !iwasaki-k
!
! Local Variables
CHARACTER(120)::INFILE 
LOGICAL INFOK,EOF 
INTEGER :: IU=1

! Functions
LOGICAL:: READSCT, READPCT
LOGICAL:: READPRI

IF (IARGC().LT.1) THEN
   WRITE(0,*) ' dump_headers - error - No input file given'
   CALL EXIT (-1)
ENDIF

CALL GETARG(1,INFILE)
!
!     Check if input file exists
INQUIRE(FILE=INFILE,EXIST=INFOK)
IF (.NOT.INFOK) THEN
   WRITE(0,*) ' dump_headers - error - Missing input file'
   CALL EXIT(-1)
ENDIF

CALL ZeroSCT(SCT)

OPEN(UNIT=IU, FILE=INFILE, FORM="UNFORMATTED", ACCESS="STREAM")
! Read the SCT
EOF=READSCT(IU,  SCT)
IF (EOF) CALL EXIT(1)
CALL FixSCTstrings(SCT)
CALL DumpSCT(SCT)
!
!!
OPEN(UNIT=2, FILE='dumpsct.bin', FORM="UNFORMATTED", ACCESS="STREAM")
write(2) SCT
close(unit=2)

!
EOF=READPCT(IU,  PCT)
IF(EOF) CALL EXIT(1)
CALL FixPCTstrings(PCT)
CALL DumpPCT(PCT)
!
OPEN(UNIT=2, FILE='dumppct.bin', FORM="UNFORMATTED", ACCESS="STREAM")
write(2) PCT
close(unit=2)

!iwasaki-k
PRI%GateCount = 1000
PRI%ReceiverCount = 8

EOF=READPRI(IU,  PRI)
IF(EOF) CALL EXIT(1)

!2回目iwasaki-k
EOF=READPCT(IU,  PCT)
IF(EOF) CALL EXIT(1)
CALL FixPCTstrings(PCT)
CALL DumpPCT(PCT)

OPEN(UNIT=2, FILE='dumppct.bin', FORM="UNFORMATTED", ACCESS="STREAM")
write(2) PCT
close(unit=2)

EOF=READPRI(IU,  PRI)
IF(EOF) CALL EXIT(1)

!3回目iwasaki-k
EOF=READPCT(IU,  PCT)
IF(EOF) CALL EXIT(1)
CALL FixPCTstrings(PCT)
CALL DumpPCT(PCT)

OPEN(UNIT=2, FILE='dumppct.bin', FORM="UNFORMATTED", ACCESS="STREAM")
write(2) PCT
close(unit=2)

EOF=READPRI(IU,  PRI)
IF(EOF) CALL EXIT(1)

!4回目iwasaki-k
EOF=READPCT(IU,  PCT)
IF(EOF) CALL EXIT(1)
CALL FixPCTstrings(PCT)
CALL DumpPCT(PCT)

OPEN(UNIT=2, FILE='dumppct.bin', FORM="UNFORMATTED", ACCESS="STREAM")
write(2) PCT
close(unit=2)

EOF=READPRI(IU,  PRI)
IF(EOF) CALL EXIT(1)

!5回目iwasaki-k
EOF=READPCT(IU,  PCT)
IF(EOF) CALL EXIT(1)
CALL FixPCTstrings(PCT)
CALL DumpPCT(PCT)

OPEN(UNIT=2, FILE='dumppct.bin', FORM="UNFORMATTED", ACCESS="STREAM")
write(2) PCT
close(unit=2)

EOF=READPRI(IU,  PRI)
IF(EOF) CALL EXIT(1)

!6回目iwasaki-k
EOF=READPCT(IU,  PCT)
IF(EOF) CALL EXIT(1)
CALL FixPCTstrings(PCT)
CALL DumpPCT(PCT)

OPEN(UNIT=2, FILE='dumppct.bin', FORM="UNFORMATTED", ACCESS="STREAM")
write(2) PCT
close(unit=2)

EOF=READPRI(IU,  PRI)
IF(EOF) CALL EXIT(1)

!7回目iwasaki-k
EOF=READPCT(IU,  PCT)
IF(EOF) CALL EXIT(1)
CALL FixPCTstrings(PCT)
CALL DumpPCT(PCT)

OPEN(UNIT=2, FILE='dumppct.bin', FORM="UNFORMATTED", ACCESS="STREAM")
write(2) PCT
close(unit=2)

EOF=READPRI(IU,  PRI)
IF(EOF) CALL EXIT(1)

!8回目iwasaki-k
EOF=READPCT(IU,  PCT)
IF(EOF) CALL EXIT(1)
CALL FixPCTstrings(PCT)
CALL DumpPCT(PCT)

OPEN(UNIT=2, FILE='dumppct.bin', FORM="UNFORMATTED", ACCESS="STREAM")
write(2) PCT
close(unit=2)

EOF=READPRI(IU,  PRI)
IF(EOF) CALL EXIT(1)

!9回目iwasaki-k
EOF=READPCT(IU,  PCT)
IF(EOF) CALL EXIT(1)
CALL FixPCTstrings(PCT)
CALL DumpPCT(PCT)

OPEN(UNIT=2, FILE='dumppct.bin', FORM="UNFORMATTED", ACCESS="STREAM")
write(2) PCT
close(unit=2)

!
END PROGRAM
