SUBROUTINE DumpPCT(PCT)
!
! T. Bullett   CIRES     04Nov08
! g95 
!
! Dump the values in a Pulse Configuration Table (PCT) from the VIPIR RIQ files
! Version 1.2 of the RIQ format 
!
! Requries the TrimNull() function from misc_utils.f90 
!
! 17Dec15 more info on tune word
!
USE misc_utils
IMPLICIT NONE
INCLUDE 'pct.f90'
!
! Tune word unit for VIPIR1 at 80 MHz, to convert to frequency in kHz.
! This is 80E6/(1000*2^32)
REAL,PARAMETER:: T32=0.0000186264514923096  
!
TYPE(PCTtype):: PCT
!
!
WRITE(*,105) '' 
WRITE(*,105) 'PCT:'
WRITE(*,101) 'pct.record_id', PCT%record_id
WRITE(*,102) 'pct.pri_ut', PCT%pri_ut
WRITE(*,102) 'pct.pri_time_offset', PCT%pri_time_offset
WRITE(*,101) 'pct.base_id',  PCT%base_id
WRITE(*,101) 'pct.pulse_id', PCT%pulse_id
WRITE(*,101) 'pct.ramp_id', PCT%ramp_id
WRITE(*,101) 'pct.repeat_id',PCT%repeat_id
WRITE(*,102) 'pct.frequency', PCT%frequency, PCT%frequency
WRITE(*,100) 'pct.nco_tune_word',PCT%nco_tune_word,PCT%nco_tune_word,T32*REAL(PCT%nco_tune_word)
WRITE(*,102) 'pct.drive_attenuation', PCT%drive_attenuation
WRITE(*,100) 'pct.pa_flags',PCT%pa_flags
WRITE(*,102) 'pct.pa_forward_power', PCT%pa_forward_power
WRITE(*,102) 'pct.pa_reflected_power', PCT%pa_reflected_power
WRITE(*,102) 'pct.pa_vswr', PCT%pa_vswr
WRITE(*,102) 'pct.pa_temperature', PCT%pa_temperature
WRITE(*,101) 'pct.procq_range_count', PCT%proc_range_count
WRITE(*,102) 'pct.proc_noise_level', PCT%proc_noise_level
WRITE(*,104) 'pct.user:',TRIM(PCT%user)
!

RETURN
100 FORMAT ('#',1X,A,T33,'0x',Z8.8,2X,I12,2X,F12.3)
101 FORMAT ('#',1X,A,T31,I12)
102 FORMAT ('#',1X,A,T31,F12.2,2X,E12.6)
104 FORMAT ('#',1X,A,T31,A)
105 FORMAT ('#',1X,A)

END
