C.
C.    FORTRAN Program To Perform A Weighted Linear Least
C.    Squares Fit To An Arbitrary Function
C.
      DIMENSION F(20,500),FW(20,500),A(20,20),Ainverse(20,20)
      DIMENSION Y(500),YW(500),YFIT(500),W(500),SIGMA(500)
      DIMENSION XI(500),RDEV(500),S(20),X(20)
         DATA YFIT/500*0./
         DATA S/20*0./
         DATA A/400*0./
         DATA XI/500*0./
         DATA Y/500*0./
         DATA SIGMA/500*1./
C.
C.    Read Input Data
C.
      NTERMS=4
      IOUT=9
      IOPT=0
         OPEN (UNIT=4,File='input.DAT')
	   OPEN (Unit=iout,File='output.dat')
            READ(4,*)NPTS
                DO I=1,NPTS
			  READ(4,*)XI(I),Y(I)
                ENDDO
C.
C.    COMPUTE FUNCTION VALUES AT EACH DATA POINT
C.
      CALL FJ(XI,F,NPTS,NTERMS)
C.
C.    COMPUTE WEIGHTING FUNCTION
C.
      IF(IOPT.EQ.1)THEN
        DO I=1,NPTS
        SIGMA(I)=Y(I)
        ENDDO
      elseif(iopt.eq.2)then
	 do i=1,npts
	 Read(4,*)sigma(i)
	 enddo
      END IF
c.
      CLOSE (UNIT=4)
      DO I=1,NPTS
      W(I)=1./SIGMA(I)
      ENDDO
        DO J=1,NTERMS
         DO I=1,NPTS
         FW(J,I)=F(J,I)*W(I)
         ENDDO
        ENDDO
           DO I=1,NPTS
           YW(I)=Y(I)*W(I)
           ENDDO
C.
C.    COMPUTE ELEMENTS OF COEFFICIENT MATRIX
C.
      DO K=1,NTERMS
        DO J=K,NTERMS
             DO I=1,NPTS
             A(K,J)=A(K,J)+FW(K,I)*FW(J,I)
             ENDDO
        ENDDO
      ENDDO
      DO K=1,NTERMS
          DO J=K+1,NTERMS
          A(J,K)=A(K,J)
          ENDDO
      ENDDO
C.
C.    COMPUTE ELEMENTS OF SOURCE VECTOR
C.
      DO K=1,NTERMS
        DO I=1,NPTS
        S(K)=S(K)+YW(I)*FW(K,I)
        ENDDO
      ENDDO
C.
C.    Compute Matrix inverse
C.
      CALL Inverse(A,Ainverse,NTERMS)
c.
c.    Compute Solution Vector
c.
      do k=1,nterms
      x(k)=0.
      do j=1,nterms
      x(k)=x(k)+Ainverse(k,j)*S(j)
      enddo
      enddo
C.
C.    COMPUTE VALUES OF FITTED FUNCTION AT EACH DATA POINT
C.
      DO J=1,NTERMS
        DO I=1,NPTS
        YFIT(I)=YFIT(I)+X(J)*F(J,I)
        ENDDO
      ENDDO
C.
C.    COMPUTE AVERAGE CHI SQUARED VALUE
C.
      CHISQR=0.
      DO I=1,NPTS
      CHISQR=CHISQR+((Y(I)-YFIT(I))*W(I))**2
      ENDDO
	chisqr=chisqr/float(npts)
C.
C.    COMPUTE AVERAGE RELATIVE DEVIATION OF FIT AND DATA
C.
      ANORM=0.
      DO I=1,NPTS
      RDEV(I)=(Y(I)-YFIT(I))/Y(I)
      ANORM=ANORM+ABS(RDEV(I))
      ENDDO
          ANORM=ANORM/FLOAT(NPTS)
C.
C.    OUTPUT
C.
      Write(iout,*)'Fitting Coefficients and Uncertainties'
	write(iout,*)' '
      DO J=1,NTERMS
      WRITE(IOUT,101)j,X(J),Ainverse(j,j)
      ENDDO
 101  Format(1x,'a(',i2,') = ',1pe11.4,5x,'Sigma**2 =',1pe11.4)
      WRITE(IOUT,*)' '
      WRITE(IOUT,*)'Average Chi Square Value =',CHISQR
	write(iout,*)'Average Relative Error =',ANORM
      WRITE(IOUT,*)' '
	Write(iout,*)'Fitting Results'
	write(iout,*)' '
	write(iout,111)
	write(iout,*)' '
      DO I=1,NPTS
      WRITE(IOUT,112)i,Xi(i),Y(I),YFIT(I),RDEV(I)
      ENDDO
 111  format(4x,'I',3x,'Independent Variable',2x,'Dependent Variable',
     %6x,'Fit',9x,'Relative Error')
 112  format(1x,i4,6x,1pe11.4,11x,1pe11.4,6x,1pe11.4,6x,1pe11.4)
      close(unit=iout)
      STOP
      END
C.
C.    SUBROUTINE TO SOLVE LINEAR SVSTEMS OF EQUATIONS By
C.	GAUSSIAN ELIMINATION WITH BACK SUBSTITUTION AND
C	PARTIAL PIVOTING
	SUBROUTINE GAUSS(A,B,X,N)
        DIMENSION A(20,20),B(20),X(20)
C.	BEGIN LOOP ON PIVOT ELEMENT
C.
        DO 10 K=1,N
C	SEARCH COLUMN K FOR MAXIMUM PIVOT ELEMENT
        TEST=0.
	DO 20 I=K,N
	IF (ABS(A(I,K)).GT.TEST)THEN
	TEST=ABS(A(I,K))
	ISTORE=I
	END IF
 20	CONTINUE
C	INTERCHANGE ROW K AND ROW ISTORE
	IF(ISTORE.NE.K)THEN
	DO 30 J=K,N
        ASTORE=A(K,J)
        A(K,J)=A(ISTORE,J)
        A(ISTORE,J)=ASTORE
 30	CONTINUE
	BSTORE=B(K)
	B(K)=B(ISTORE)
	B(ISTORE)=BSTORE
	END IF
	PIVOT=A(K,K)
        A(K,K)=1.
C       DIVIDE ROW K By THE PIVOT ELEMENT
	B(K)=B(K)/PIVOT
      DO 40 J=K+1,N
 	A(K,J)=A(K,J)/PIVOT
 40   Continue
C	ZERO COLUMN K
        DO 50 I=K+1,N
	AMULT=A(I,K)
        A(I,K)=0.
        IF(AMULT.Eq.0.)GO TO 50
        B(I)=B(I)-AMULT*B(K)
      DO 55 J=K+1,N
 	A(I,J)=A(I,J)-AMULT*A(K,J)
 55   Continue
 50	CONTINUE
 10	CONTINUE
C	BACK SUBSTITUTION STEP
	X(N)=B(N)
        DO 60 I=N-1,1,-1
        SUM=0.
      DO 70 J=I+1,N
 	SUM=SUM+X(J)*A(I,J)
 70   Continue
	X(I)=B(I)-SUM
 60	CONTINUE
	RETURN
        END
c.
c.    Subroutine to compute the matrix inverse
c.
      Subroutine Inverse(A,Ainverse,NTERMS)
      Dimension A(20,20),Ainverse(20,20),Astore(20,20),x(20)
	Dimension b(20)
c.
      do i=1,nterms
      do j=1,nterms
      Astore(i,j)=A(i,j)
      enddo
      enddo
c.
      do k=1,nterms
       do i=1,nterms
       do j=1,nterms
       A(i,j)=Astore(i,j)
       enddo
       enddo
         do i=1,nterms
         if(i.eq.k)then
         b(i)=1.
         else
         b(i)=0.
         endif
         enddo
      CALL GAUSS(A,b,X,NTERMS)
	do j=1,nterms
      Ainverse(j,k)=x(j)
      enddo
      enddo
      Return
      end
