!
! Define the Pulse Configuration Table (PCT) structure for Version 2.0 of the
! Raw Inphase & Quadrature (RIQ) file format for the Scion HF Radar (VIPIR) Mark 2
!
!
! T. Bullett    27 November 2015   gfortran 
! Adapted from: 
! R. Livingston           gcc
! Using the work of Mr. Muto, NICT, Japan.  
!
!
! Pulse Configuration Table   Version 2.0 with 64 bit integers
TYPE :: PCT2type    
INTEGER(KIND=8) :: record_id           ! Sequence number of this PCT
REAL(KIND=8)    :: pri_ut              ! UT of this pulse
REAL(KIND=8)    :: pri_time_offset     ! Time read from system clock, not precise.
INTEGER(KIND=8) :: base_id             ! Base Frequency counter
INTEGER(KIND=8) :: pulse_id            ! pulse set element for this PRI
INTEGER(KIND=8) :: ramp_id             ! ramp set element for this PRI
INTEGER(KIND=8) :: repeat_id           ! ramp repeat element for this PRI
INTEGER(KIND=8) :: loop_id             ! Outer loop element for this PRI
REAL(KIND=4)    :: frequency           ! Frequency of observation (kHz)
REAL(KIND=4)    :: dummy1           ! Frequency of observation (kHz)
INTEGER(KIND=8) :: nco_tune_word       ! Tuning word sent to the receiver
REAL(KIND=4)    :: drive_attenuation   ! Low-level drive attenuation [dB]
REAL(KIND=4)    :: dummy2           ! Frequency of observation (kHz)
INTEGER(KIND=8) :: pa_flags            ! Status flags from amplifier
REAL(KIND=4)    :: pa_forward_power    ! Forward power from amplifier
REAL(KIND=4)    :: pa_reflected_power  ! Reflected power from amplifier
REAL(KIND=4)    :: pa_vswr             ! Voltage Standing Wave Ratio from amplifier
REAL(KIND=4)    :: pa_temperature      ! Amplifier temperature
INTEGER(KIND=8) :: proc_range_count    ! Number of range gates kept this PRI
REAL(KIND=4)    :: proc_noise_level    ! Estimated noise level for this PRI
REAL(KIND=4)    :: dummy3           ! Frequency of observation (kHz)
CHARACTER(64)   :: user                ! Spare space for user-defined information    
END TYPE PCT2type
