SUBROUTINE PRI2Stat(DEBUG,PRI,RG1,RG2,NSTAT  PRIStats)
!
! Perform statististics on the data in the PRI and place them in the Stats object 
!
! Terry Bullett
! University of Colorado Boulder
!
! 24Feb15
!
! Linux using gfortran compiler
!
! License:
! This software is the intellectual property of the author.
! Generous terms of use are likely if you ask nicely.
! 
! "To give glory to God by exploring His universe with reverence"  
!
! Requires:
!
!
! Revision History
! 24Feb15 Version 0.10 -  Initial version  
!
! Comments:  It's a little crazy to place this routine 3 deep into the code, it could possibly get moved to 2 deep
! by calling it before PRI2Intercept, but probably not.  And its crazy to have this arbitrariy mapping between statistic number
! and the items that is being estimated, and all these stattistic modes defined at this level, but this is my thinking
! at the time I wrote this.  Maybe too much time at Jang Bogo and on the Araon.  
!
IMPLICIT NONE
INCLUDE 'type-param.f90'! Global Types and parameter definitions  
INCLUDE 'sct.f90'       ! SCT
INCLUDE 'pct.f90'       ! SCT
INCLUDE 'pri.f90'       ! PRI
INCLUDE 'stats.f90'     ! Statistics Object
!
! Passed arguments
LOGICAL,INTENT(IN):: DEBUG
!REAL,INTENT(IN)::RMIN        ! Mimimum correlation Coefficient to accept
INTEGER,INTENT(IN):: RG1,RG2  ! Range Gate Mask for this calculation
INTEGER,INTENT(IN):: NUMSTAT  ! Number of Different Statisitics for this PRI.  There will be a scheme to this   
TYPE(PRItype),INTENT(IN) :: PRI
TYPE(STATtype),INTENT(OUT) ::
!
! Local Variables
INTEGER::IRG
!
PRIStats%%Frequency=PRI%Frequency
!
PRIStat%
RETURN
END SUBROUTINE PRI2Stats

DO IRG=Intercept%RG1,Intercept%RG2
      IF (PRI%CorrC(IRG,1)*PRI%CorrC(IRG,2) .LT. RMIN) CYCLE                !  Reject data with large Rx*Ry
      Intercept%NumAve = Intercept%NumAve + 1
      DO I=1,3 
         Intercept%VK(I) = Intercept%VK(I) + PRI%VK(IRG,I)
      ENDDO 
   ENDDO
   IF(Intercept%NumAve.GT.0) THEN
      Intercept%VK = Intercept%VK/REAL(Intercept%NumAve)
   ENDIF
   Intercept%VKVar=0.0
   DO IRG=Intercept%RG1,Intercept%RG2
      DO I=1,3
        Intercept%VKVar(I) = (PRI%VK(IRG,I) - Intercept%VK(I))**2
      ENDDO
   ENDDO
   IF(Intercept%NumAve.GT.1) THEN
      Intercept%VKVar = SQRT(Intercept%VKVar)/(Intercept%NumAve-1)
   ELSE
      Intercept%VKVar = 1.0
   ENDIF


