SUBROUTINE SCTPCT2PRI(SCT,PCT,  PRI)
!
! T. Bullett   29Oct08 
! Map info from the SCT and PCT into the PRI structure
! Version 1 of RIQ file
!
! 14Feb09  TWB  Re-defined PRI and moved much of this into Ionogram structure
!               Frequencies in kHz internally.
! 08Oct14  TWB  Removed unused RANGE0 argument
!
! 21Feb15  TWB  Updated what is placed in the PCT, to improve raw data handling
!               Changed the timings to microseconds from nanoseconds.  More rational
IMPLICIT NONE
!
REAL,PARAMETER :: Kmpus=149.896229       ! Kilometers per millisecond 
!
INCLUDE 'type-param.f90'! Global Types and parameter definitions 
INCLUDE 'sct.f90'     ! SCT
INCLUDE 'pct.f90'     ! PCT
INCLUDE 'pri.f90'     ! PRI
!

TYPE(SCTtype),INTENT(IN) :: SCT
TYPE(PCTtype),INTENT(IN) :: PCT
TYPE(PRItype),INTENT(OUT) :: PRI
!
! Local variables
INTEGER:: IFRQ,IRGT
!
!
PRI%ReceiverCount=SCT%receiver%rx_chan
PRI%GateCount=SCT%timing%gate_count
PRI%GateStep=REAL(SCT%timing%gate_step)  ! Time in microseconds 
PRI%GateStart=REAL(SCT%timing%gate_start)  ! Time in microseconds 
IFRQ=PCT%base_id 
PRI%Frequency=PCT%Frequency
PRI%PulsetLength=SCT%frequency%pulse_count
PRI%PulsetIndex=PCT%pulse_id + 1
PRI%UTtime=REAL(PCT%pri_ut)
PRI%RelativeTime=SCT%timing%pri*REAL(PCT%record_id - 1)
! Add time to the range gates
DO IRGT=1,PRI%GateCount
   PRI%RGTime(IRGT) = PRI%GateStart + REAL(IRGT-1)*PRI%GateStep
ENDDO

100 FORMAT (I4.4,1X,I3.3,1X,I2.2,':',I2.2,':',I2.2) 
END SUBROUTINE SCTPCT2PRI 
