SUBROUTINE XYZ2RTP(C,  S)
!
! Convert Cartesian coordinated X,Y,Z into spherical coordinates R,Theta,Phi
!
!  18Feb15   TWB
!  University of Colorado
!
!  Angles are in radians.
!  Theta=Phi=0 if R-0
!  Phi=0 if Theta=0
!
REAL,DIMENSION(3),INTENT(IN):: C(3)
REAL,DIMENSION(3),INTENT(OUT):: S(3)
!
!
S=0
S(1) = SQRT(C(1)**2 + C(2)**2 + C(3)**2)
IF (S(1).EQ.0) RETURN
!  Since z = r*cos(theta)
S(2) = ACOS(C(3)/S(1))
IF(SIN(S(2)).EQ.0) RETURN
! Since x = r*sin(theta)*cos(phi)
! S(3) = ACOS(C(1)/(S(1)*SIN(S(2))))   
S(3) = ATAN2(C(2), C(1))
RETURN
END SUBROUTINE XYZ2RTP
